<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\ServiceRequest;
use App\Service;
use App\ServiceDescription;
use App\ServicePhoto;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\View\View;
use Illuminate\Http\Request;

class ServiceController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/services';
    /** View folder */
    private $viewDirectory= 'admin.services.';

    /**
     * Display a listing of the resource.
     *
     * @return View
     */
    public function index() :View
    {
        $title= __('services.head');
        return view($this->viewDirectory.'index',compact('title'));
    }


    /**
     * return data of the services.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Service::latest()
            ->join('service_descriptions AS SD', 'services.id', 'SD.service_id')
            ->where('SD.language_id', currentLanguage()->id)
            ->select(['SD.title', 'services.*']);

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->title) {
            $query->whereHas('descriptions', function ($query) use ($request) {
                return $query->where('title', 'LIKE', '%'.$request->title.'%');
            })->cursor();
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $services= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('services'));
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action= route('services.store');
        $head = metaFields('services', 'add_new', getCurrentLocale()) ?? __('services.new');
        return view($this->viewDirectory.'form', compact('action', 'head'));

    }

    /**
     * Store a newly created resource in storage.
     * @param ServiceRequest $request
     * @return RedirectResponse
     */
    public function store(ServiceRequest $request) :RedirectResponse
    {
        $service = Service::create($request->all());
        // Create Records
        $this->saveData($request, $service->id);
        // Return Redirect Response
        return redirect($this->redirectSuccessPath)->withMessage(__('dashboard.saveDone'));
    }

    /**
     * how the form for editing the specified resource.
     * @param Service $service
     * @return View
     */
    public function edit(Service $service): View
    {
        $action= route('services.update', $service->id);
        $head = metaFields('services', 'edit', getCurrentLocale()) ?? __('services.edit');
        $query = ServiceDescription::where('service_id', $service->id)
            ->join('languages', 'languages.id', 'service_descriptions.language_id')
            ->select(['service_descriptions.*', 'languages.local']);
        $serviceDescription= $query->get();
        foreach ($serviceDescription as $row) {
            $service[$row->local]= $row;
        }

        return view( $this->viewDirectory.'form', compact('service', 'action', 'head') );

    }

    /**
     * Update the specified resource in storage.
     * @param ServiceRequest $request
     * @param Service $service
     * @return RedirectResponse
     */
    public function update(ServiceRequest $request, Service $service) :RedirectResponse
    {
        $service->update(['image' => $request->image ?? null]);

        // Delete old description
//        ServiceDescription::where('service_id', $service->id)->delete();

        ServicePhoto::where('service_id', $service->id)->delete();

        // Update Records
        $this->saveData($request, $service->id);
        // Return Redirect Response
        return redirect($this->redirectSuccessPath)->withMessage(__('dashboard.saveDone'));
    }


    /**
     * Handle Save form data
     *
     * @param ServiceRequest $request
     * @param null $service_id
     * @return void
     */

    private function saveData(ServiceRequest $request, $service_id = null ):void
    {
        $descriptions = ServiceDescription::where('service_id', $service_id)->cursor();

        if ($descriptions->count()) {
            foreach(languages() as $language)
            {
                $data = [
                    'language_id' => $language->id,
                    'title' => $request['title_'.$language->local] ,
                    'description' => $request['description_'.$language->local],
                    'service_id' => $service_id
                ];

                ServiceDescription::where('service_id', $service_id)->where('language_id', $language->id)->update($data);
            }
        } else {
            foreach(languages() as $language)
            {
                $data = [
                    'language_id' => $language->id,
                    'title' => $request['title_'.$language->local] ,
                    'description' => $request['description_'.$language->local],
                    'service_id' => $service_id
                ];

                ServiceDescription::create($data);
            }
        }


        if ($request->has('images')){
            foreach ($request->images as $image) {
                ServicePhoto::create([
                    'photo' => $image,
                    'service_id' => $service_id
                ]);
            }
        }

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws \Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $service = Service::withTrashed()->find($id);
        if ($service) {
            if ($service->deleted_at) {
                $service->forceDelete();
            } else {
                $service->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several services by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Service::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Service::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $service = Service::withTrashed()->find($id);

        if ($service){
            $service->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several services by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $service = Service::whereIn('id', $request->ids)->onlyTrashed();
        if ($service){
            $service->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}

